﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;

namespace SL_RadMenu
{
    public class ViewModel : ViewModelBase
    {
        public DelegateCommand MyCommand { get; set; }

        private ObservableCollection<ViewModel> items;
        private string header;
        private bool isChecked;

        public bool IsChecked
        {
            get
            {
                return this.isChecked;
            }
            set
            {
                if (this.isChecked != value)
                {
                    this.isChecked = value;
                    this.OnPropertyChanged("IsChecked");
                    this.OnChecked();
                }
            }
        }


        public string Header
        {
            get
            {
                return this.header;
            }
            set
            {
                if (this.header != value)
                {
                    this.header = value;
                    this.OnPropertyChanged("Header");
                }
            }
        }

        public ObservableCollection<ViewModel> Items
        {
            get
            {
                return this.items;
            }

            set
            {
                if (this.items != value)
                {
                    this.items = value;
                }
            }
        }

        public ViewModel()
        {
            Init();
        }

        public ViewModel(string header)
        {
            Init();
            this.header = header;
        }

        private void LoadModuleCommand(object parameter)
        {
            // do something
        }

        private void Init()
        {
            this.items = new ObservableCollection<ViewModel>();
            MyCommand = new DelegateCommand(LoadModuleCommand);
            this.OnPropertyChanged(() => MyCommand);
        }

        private void OnChecked()
        {
            // do something
        }
    }

    public class DelegateCommand : ICommand
    {
        private Action<object> ExecutedCallBack;

        public DelegateCommand(Action<object> callBack)
        {
            ExecutedCallBack = callBack;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            if (this.ExecutedCallBack != null)
            {
                this.ExecutedCallBack(parameter);
            }
        }
    }

}
